;-----------------------------------------
; startup code
;-----------------------------------------
	.module		crt0.s
	.include	"gcb11.inc"
	.area   DIRECT	(ABS,PAG)
	.blkb	0x60
; 
; Pseudo regs
;
ZD0::	.blkb	2
ZD1::	.blkb	2
ZD2::	.blkb	2
ZD3::	.blkb	2
ZD4::	.blkb	2
ZD5::	.blkb	2
ZD6::	.blkb	2
ZD7::	.blkb	2
ZD8::	.blkb	2
ZB0::	.blkb	1
ZB1::	.blkb	1
ZB2::	.blkb	1
ZB3::	.blkb	1
ZB4::	.blkb	1
;
; scratch area
;
ZXT::	.blkb	2
;
; stack area
;
	.area   STACK	(ABS)
	.org	0x600
__stack_end::
	.byte	0
    	.blkb	511	; reserve space
__stack_begin::

;
; startup area
;
	.area   STARTUP		(ABS)
	.org	0x100
;
;	setup stack
;
_startup::
	lds     #__stack_begin-1  ; initialize stack pointer

	xgdy			; pass result of config change
;
;  setup the heap
;
; If you have a malloc, put code here
;
;	jsr	_init_malloc	; set up the heap
;
;       do the call to main()
;
	cli
	jsr     _main            ; main()
_exit::;
;
; Note: This is grom specific. You should add you own cleanup here
;
	ldd	stdio
	std	*ZD0
	jsr	_gi_strm_flush
	jsr	_gi_intr_swi
exit::	bra     exit
___main::
	rts	; return from function

;-----------------------------------------
; end startup code
;-----------------------------------------

;-----------------------------------------
; required gcclib code
;-----------------------------------------
;
; signed divide: assumes numerator on stack and denominator on stack + 2
; returns quotient in D
;
___divhi3::
	tsx
	ldd	4,x
	bge	$1
	ldd	#0
	subd	4,x
$1:
	std	*ZXT
	ldd	2,x
	bge	$2
	ldd	#0
	subd	2,x
$2:
	xgdx
	ldd	*ZXT
	idiv
	stx	*ZXT
	tsx
	ldd	4,x
	clrb
	eora	2,x
	anda	#0x80
	beq	$3
	ldd	#0
	subd	*ZXT
	bra	$4
$3:
	ldd	*ZXT
$4:
	rts

;
; signed modulo divide: assumes numerator on stack and denominator on stack + 2
; returns remainder in D
;
___modhi3::
	tsx
	ldd	4,x
	bge	$5
	ldd	#0
	subd	4,x
$5:
	std	*ZXT
	ldd	2,x
	bge	$6
	ldd	#0
	subd	2,x
$6:
	xgdx
	ldd	*ZXT
	idiv
	std	*ZXT
	tsx
	ldd	4,x
	clrb
	eora	2,x
	anda	#0x80
	beq	$7
	ldd	#0
	subd	*ZXT
	bra	$8
$7:
	ldd	*ZXT
$8:
	rts

;
; signed multiply: assumes e1 in D and e2 on stack
; returns result (e1 * e2) in D
;
___mulhi3::
	pulx
	pshx
	pshx
	xgdx
	pshx
	tsx
	ldab	1,x
	ldaa	7,x
	mul
	std	*ZXT
	ldab	0,x 
	ldaa	7,x
	mul
	tba
	clrb
	addd	*ZXT
	std	*ZXT
	ldab	1,x
	ldaa	6,x
	mul
	tba
	clrb
	addd	*ZXT
	pulx
	pulx
	rts

;
; See aux-output.c module for more details on these routines
;
; __pushregs::
; 	rts
;
; __pullregs::
; 	rts

;
;	gcc/grom interface to dispatch tables.
;
;	Note: The following needs to ldd and std the ZD0 pseudo register
;	in order to maintain compatibility with the functions provided
;	in rom with the GCB11 controller board. If you use your own
;	C-Lib, this stuff is not needed.
;
__call_grom::
	pulx			; snarf current return address
	stx	*ZXT		; and store in a temp
	ldx	#__grom_ret
	pshx			; push new return address on stack
	xgdx			; Actual table entry was in d, now in x
	ldd	*ZD0
	jmp	0,x		; do the call
__grom_ret:
	std	*ZD0
	ldx	*ZXT
	pshx			; push original return address on stack
	rts			; and return

;-----------------------------------------
; end required gcclib code
;-----------------------------------------

;
;	clib jump table
;
;	ctype.h
;
_isalnum::
	ldd	#1*3+calltbl_off
	jmp	__call_grom
_isalpha::
	ldd	#2*3+calltbl_off
	jmp	__call_grom
_iscntrl::
	ldd	#3*3+calltbl_off
	jmp	__call_grom
_isdigit::
	ldd	#4*3+calltbl_off
	jmp	__call_grom
_isgraph::
	ldd	#5*3+calltbl_off
	jmp	__call_grom
_islower::
	ldd	#6*3+calltbl_off
	jmp	__call_grom
_isprint::
	ldd	#7*3+calltbl_off
	jmp	__call_grom
_ispunct::
	ldd	#8*3+calltbl_off
	jmp	__call_grom
_isspace::
	ldd	#9*3+calltbl_off
	jmp	__call_grom
_isupper::
	ldd	#10*3+calltbl_off
	jmp	__call_grom
_isxdigit::
	ldd	#11*3+calltbl_off
	jmp	__call_grom
_toupper::
	ldd	#12*3+calltbl_off
	jmp	__call_grom
_tolower::
	ldd	#13*3+calltbl_off
	jmp	__call_grom
;
;
;
_getchar::
	ldd	#112*3+calltbl_off
	jmp	__call_grom
_gets::
	ldd	#113*3+calltbl_off
	jmp	__call_grom
_printf::
	ldd	#114*3+calltbl_off
	jmp	__call_grom
_putchar::
	ldd	#115*3+calltbl_off
	jmp	__call_grom
_puts::
	ldd	#116*3+calltbl_off
	jmp	__call_grom
_sprintf::
	ldd	#117*3+calltbl_off
	jmp	__call_grom
_vprintf::
	ldd	#118*3+calltbl_off
	jmp	__call_grom
_vsprintf::
	ldd	#119*3+calltbl_off
	jmp	__call_grom
;
;
;
_abs::
	ldd	#120*3+calltbl_off
	jmp	__call_grom
_atoi::
	ldd	#121*3+calltbl_off
	jmp	__call_grom
_div::
	ldd	#123*3+calltbl_off
	jmp	__call_grom
;
;	string.lib
;
_memchr::
	ldd	#131*3+calltbl_off
	jmp	__call_grom
_memcmp::
	ldd	#132*3+calltbl_off
	jmp	__call_grom
_memmove::
	ldd	#133*3+calltbl_off
	jmp	__call_grom
_memcpy::
	ldd	#134*3+calltbl_off
	jmp	__call_grom
_memset::
	ldd	#135*3+calltbl_off
	jmp	__call_grom
;
_strcat::
	ldd	#136*3+calltbl_off
	jmp	__call_grom
_strchr::
	ldd	#137*3+calltbl_off
	jmp	__call_grom
_strcmp::
	ldd	#138*3+calltbl_off
	jmp	__call_grom
_strcpy::
	ldd	#139*3+calltbl_off
	jmp	__call_grom
_strcspn::
	ldd	#140*3+calltbl_off
	jmp	__call_grom
;
_strlen::
	ldd	#141*3+calltbl_off
	jmp	__call_grom
_strncat::
	ldd	#142*3+calltbl_off
	jmp	__call_grom
_strncmp::
	ldd	#143*3+calltbl_off
	jmp	__call_grom
_strncpy::
	ldd	#144*3+calltbl_off
	jmp	__call_grom
_strpbrk::
	ldd	#145*3+calltbl_off
	jmp	__call_grom
;
_strrchr::
	ldd	#146*3+calltbl_off
	jmp	__call_grom
_strspn::
	ldd	#147*3+calltbl_off
	jmp	__call_grom
_strstr::
	ldd	#148*3+calltbl_off
	jmp	__call_grom
_strtok::
	ldd	#149*3+calltbl_off
	jmp	__call_grom
;
;	gios routines needed for startup
;
_gi_strm_flush::
	ldd	#44*3+calltbl_off
	jmp	__call_grom
_gi_strm_size::
	ldd	#55*3+calltbl_off
	jmp	__call_grom
_gi_intr_swi::
	ldd	#41*3+calltbl_off
	jmp	__call_grom
;
;	end crt0.s
;
;	.include	"gios.s"
;	.include	"utldbg.s"
;	.include	"malloc.s"
;-----------------------------------------
; start use code 
;-----------------------------------------
	.area	_CODE
